// CPUClient for GlobalStat
//
// Copyright  1997 Olivier Wittenberg

#include "CPUClient.h"

//
// Constructor: atomic_add is not really necessary here...
//

long CPUClient::ActiveCount = 0;

CPUClient::CPUClient (BLooper *l, const char *name, const char *title, long whichcpu)
	: GClient (l, name, title, NULL, GS_TYPE_FLOAT, 0, 100), cpu (whichcpu)
{
	atomic_add (&ActiveCount, 1);

	system_info si;
	get_system_info (&si);
	last_system_time = system_time ();
	last_active_time = si.cpu_infos[cpu].active_time;
}


//
// KickedOut
//

void CPUClient::KickedOut ()
{
	if (atomic_add (&ActiveCount, -1) == 1)
		be_app->PostMessage (B_QUIT_REQUESTED);
}


//
// SendCPULoad
//

void CPUClient::SendCPULoad ()
{
	double st, at;

	{
		system_info si;

		get_system_info (&si);
		st = system_time ();
		at = si.cpu_infos[cpu].active_time;
	}

	SendData ((at - last_active_time) / (st - last_system_time) * 100.);

	last_active_time = at;
	last_system_time = st;
}