// GlobalStat Client Object, header
//
// Copyright  1997 Olivier Wittenberg

#pragma once

//----------------------------------------------------------------------------------

// Client errors
enum {
	GSERR_NO_ERROR,
	GSERR_GS_NOT_IN_ROSTER,
	GSERR_MEMORY,
	GSERR_BAD_REPLY,
	GSERR_NO_REPLY,
	GSERR_CANNOT_SEND,
	GSERR_WRONG_PARAMETERS
};

// GlobalStat data types
const bool GS_TYPE_FLOAT = FALSE,
		   GS_TYPE_LONG  = TRUE;

// GlobalStat alert levels
const short GS_ALERT_NONE    = 0,
			GS_ALERT_WARNING = 1,
			GS_ALERT_ERROR   = 2,
			GS_ALERT_FATAL   = 3;

//----------------------------------------------------------------------------------

class GClient : public BHandler
{
public:
	GClient (BLooper *, const char *, const char *, const char *, bool, float = 0, float = 0);
	virtual ~GClient ();

	void SendData		(float);
	void SetAlertLevel	(long);
	void SetMaximum		(float);
	void Disconnect		();

	void MessageReceived (BMessage *);

	int Error () const
	{ return (_error); }

	bool IsConnected () const
	{ return (_connected); }

	virtual void KickedOut ()
	{}

private:
	BMessenger *_toglobalstat;
	long _gsid;
	int _error;
	bool _datatype, _connected;
};