// GlobalStat, file gsactiveview.h
//
// Copyright  1997 Olivier Wittenberg

#pragma once

class GSActiveView : public BView
{
protected:

	// CtMax(): returns the maximum value (either set by GlobalStat or by the client
	//           by sending GS_SETMAX)
	// CtDatatype(): either GS_TYPE_FLOAT or GS_TYPE_LONG
	// CtValueF() and CtValueL() return the current value to be displayed.

	// Warning: you should call CtValueF or CtValueL accordingly to CtDatatype()...

	float CtMax () const;
	bool  CtDatatype () const;
	float CtValueF () const;
	long  CtValueL () const;

public:
	GSActiveView (BRect, ulong);
	virtual ~GSActiveView ();

	virtual void NewValue (bool value_has_changed)
	{
		// If you override this function, you can easily keep track of previous values.
		// Most add-ons want to override it: for example a status bar add-on doesn't want
		// to invalidate the whole frame.
		if (value_has_changed)
			Invalidate ();
	}
};